/*
 *********************************************
 **	 all die GUI-spielereien und die Prefs	**
 *********************************************
 */



/*
 **********
 * Events *
 **********
 */

/*if(window.widget) {
	widget.onshow = onShow;
	widget.onhide = onHide;
}*/



/*
 *********
 * Prefs *
 *********
 */

function savePrefs() {
	if(window.widget) {
		var opt = document.getElementById("ztag");
		var optval = opt.options[opt.selectedIndex].value;
		widget.setPreferenceForKey(optval, "day");
		opt = document.getElementById("uhrzeit");
		optval = opt.options[opt.selectedIndex].value;
		widget.setPreferenceForKey(optval, "hour");
		opt = document.getElementById("sparte");
		optval = opt.options[opt.selectedIndex].value;
		widget.setPreferenceForKey(optval, "channelkind");
		opt = document.getElementById("sender");
		optval = opt.options[opt.selectedIndex].value;
		widget.setPreferenceForKey(optval, "channel");
		optval = (document.getElementById("kurzInfoStandard").checked ? "1" : "0");
		widget.setPreferenceForKey(optval, "showShortDesc");
		opt = document.getElementById("erinnerung");
		optval = opt.options[opt.selectedIndex].value;
		widget.setPreferenceForKey(optval, "reminder");
	}
	getdefault();
	hidePrefs();
}

function showPrefs() {
	var now = new Date();
	var today = now.getDate();
	var tage = new Array("Sonntag","Montag","Dienstag","Mittwoch","Donnerstag","Freitag","Sonnabend");
	var elem = document.getElementById('ztag');
	
	for (i = 3; i < 8; i++)
	{
		now.setDate(today + i -1);
		elem.options[i].text = tage[now.getDay()] + ', ' + now.getDate() + '.' + (now.getMonth() + 1) + '.';
	}

	var front = document.getElementById("frontDiv");
	var back = document.getElementById("prefDiv");
	
	// showVersion();
	
	if(window.widget)
		widget.prepareForTransition("ToBack");
	
	hideDrawer();			
	front.style.display = "none";
	back.style.display = "block";
		
	if(window.widget)
		setTimeout("widget.performTransition();", 0);	 
}

function hidePrefs() {
	var front = document.getElementById("frontDiv");
	var back = document.getElementById("prefDiv");
	
	// refreshMode = getRefreshMode();
	// updateTVListing();
	
	if(window.widget)
		widget.prepareForTransition("ToFront");
				
	front.style.display = "block";
	back.style.display = "none";
		
	if(window.widget)
		setTimeout("widget.performTransition();", 0);
}



/*
 *******************
 * onShow + onHide *
 *******************
 */

function onShow() {
	// updateTVListing();
	if (currentlyloading) startProgressAnimation();
	else if (getListingTime() == "jetzt") getdefault();
}

function onHide() {
	stopProgressAnimation();
}




/*
 ***************
 * Transitions *
 ***************
 */

var drawer = { timer:null, current:0, to:44, contentpadding:28 };

function resizeDrawer() {
	/*
	das erzwungen 0px hohe element 'drawer' wird beim einblenden auf die Grsse vom Text enthaltenden 'drawercontent' angepasst oder auf 0 zurckgestellt
	*/
	var drawercontent = document.getElementById('drawercontent');
	
	if(drawer.timer) {
		clearInterval(drawer.timer);
		drawer.timer = null;
	}
	
	drawer.to = document.defaultView.getComputedStyle(drawercontent).getPropertyValue('height').replace(/px/, '') *1 + drawer.contentpadding;
	
	//alert('resizeDrawer(): starting to resize drawer from ' + drawer.current + ' to ' + drawer.to);
	drawer.timer = setInterval("animateDrawer()", 30);
	animateDrawer();
}

function hideDrawer() {
	if(drawer.timer) {
		clearInterval(drawer.timer);
		drawer.timer = null;
	}
	
	if(drawer.current == 0) return;
	
	var drawerDiv = document.getElementById('drawer');
	var superParentDiv = document.getElementById('superParentDiv');
	
	if(window.widget)
		window.resizeBy(0, -drawer.current);
	superParentDiv.style.bottom = '0px';	// keep bottom of main table away from growing drawer
	drawerDiv.style.height = '0px';			// set drawer to desired size
	
	drawer.current = 0;
	
	document.getElementById('toggledrawer').style.backgroundImage = "url(Images/drawerDown.png)";
}

function toggleDrawer() {
	/*
	das erzwungen 0px hohe element 'drawer' wird beim einblenden auf die Grsse vom Text enthaltenden 'drawercontent' angepasst oder auf 0 zurckgestellt
	*/
	var drawercontent = document.getElementById('drawercontent');
	
	if(drawer.timer) {
		clearInterval(drawer.timer);
		drawer.timer = null;
	}
	
	if(drawer.current > 0)
		drawer.to = 0;
	else
		drawer.to = document.defaultView.getComputedStyle(drawercontent).getPropertyValue('height').replace(/px/, '') *1 + drawer.contentpadding;
	
	//alert('toggleDrawer(): starting to resize drawer from ' + drawer.current + ' to ' + drawer.to);
	drawer.timer = setInterval("animateDrawer()", 30);
	animateDrawer();
}

function animateDrawer() {
	var drawerDiv = document.getElementById('drawer');
	var superParentDiv = document.getElementById('superParentDiv');
	var diff = drawer.to - drawer.current;
	
	var by = (diff > 0) ? Math.ceil(diff * 0.4) : Math.floor(diff * 0.4);
	var to = by + drawer.current;
	drawer.current = to;
	
	if(diff != 0) {
		//alert('resizing to ' + to + 'px');
		drawerDiv.style.height = to + 'px';				// grow drawerbox
		superParentDiv.style.bottom = to + 'px';		// keep bottom of main table away from growing drawer
		if(window.widget)
			window.resizeBy(0, by);
	}
	else {
		clearInterval(drawer.timer);
		drawer.timer = null;
		document.getElementById('toggledrawer').style.backgroundImage = (drawer.current == 0) ? "url(Images/drawerDown.png)" : "url(Images/drawerUp.png)";
	}
}


/*
 * ProgressBar
 */

var progressbar = { preloaded:false, timer:null, index:0 }

function preloadImages() {
	if(! progressbar.preloaded) {
		var ImgArr = new Array();
		for(i = 0; i < 10; i++) {
			ImgArr[i] = new Image();
			ImgArr[i].src = "Images/progressBar" + i + ".png"
		}
	}
	progressbar.preloaded = true;
}
function startProgressBar() {
	preloadImages();
	document.getElementById('progressbar').style.display = 'block';
	progressbar.timer = setInterval("animateProgressBar()", 30);
}

function stopProgressBar() {
	document.getElementById('progressbar').style.display = 'none';
	clearInterval(progressbar.timer);
	progressbar.timer = null;
}

function animateProgressBar() {
	if(! progressbar.index)
		progressbar.index = 10;
	progressbar.index--;
	if(progressbar.index < 0)
		progressbar.index = 9;
	
	document.getElementById('progressbar').style.backgroundImage = "url(Images/progressBar" + progressbar.index + ".png)";
}

function blendFromTo(from_id, to_id) {
	var from = document.getElementById(from_id);
	var to = document.getElementById(to_id);
	
	if(from && to) {
		from.style.display = 'none';
		to.style.display = 'block';
	}
}





/*
 ************
 * by Apple *
 ************
 */


/*
 * Window-resizing (modified)
 */
 
var lastPos;

function mouseDown(event) {
	var x = event.x + window.screenX;
	var y = event.y + window.screenY;
	
	document.addEventListener("mousemove", mouseMove, true);
	document.addEventListener("mouseup", mouseUp, true);
	lastPos = {x:x, y:y};
	event.stopPropagation();
	event.preventDefault();
}

function mouseMove(event) {
	var myevent = { x:(event.x < 250 ? 250 : event.x), y:(event.y < 220 ? 220 : event.y) };
	var screenX = myevent.x + window.screenX;
	var screenY = myevent.y + window.screenY;
	
	window.resizeBy(screenX - lastPos.x, screenY - lastPos.y);
	calculateAndShowThumb(document.getElementById('content'));

	lastPos = {x:screenX, y:screenY};
	event.stopPropagation();
	event.preventDefault();
}

function mouseUp(event) {
	document.removeEventListener("mousemove", mouseMove, true);
	document.removeEventListener("mouseup", mouseUp, true); 
	event.stopPropagation();
	event.preventDefault();
	
	// resize Drawer if it is visible
	if(drawer.current > 0) {
		resizeDrawer();
	}
	calculateAndShowThumb(document.getElementById('content'));
	
	// save in Prefs??
}



/*
 * i-Button
 */

var flipShown = false;
var animation = { duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null };

function mousemove(event) {
	if(!flipShown) {
		if (animation.timer != null) {
			clearInterval(animation.timer);
			animation.timer = null;
		}
 
		var starttime = (new Date).getTime() - 13;
 
		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById('flip');
		animation.timer = setInterval("animate();", 13);
		animation.from = animation.now;
		animation.to = 1.0;
		animate();
		flipShown = true;
	}
}


function mouseexit(event) {
	if(flipShown) {
		
		// fade out the info button
		if (animation.timer != null)
		{
			clearInterval (animation.timer);
			animation.timer	= null;
		}

		var starttime = (new Date).getTime() - 13;

		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById('flip');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 0.0;
		animate();
		flipShown = false;
	}
}

function animate() {
	var T;
	var ease;
	var time = (new Date).getTime();
	
	T = limit_3(time-animation.starttime, 0, animation.duration);

	if (T >= animation.duration) {
		clearInterval (animation.timer);
		animation.timer = null;
		animation.now = animation.to;
	}
	else {
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
		animation.now = computeNextFloat (animation.from, animation.to, ease);
	}

	animation.firstElement.style.opacity = animation.now;
}

function limit_3(a, b, c) {
	return a < b ? b : (a > c ? c : a);
}

function computeNextFloat(from, to, ease) {
	return from + (to - from) * ease;
}


// these functions are called when the info button itself receives onmouseover and onmouseout events (by Apple)

function enterflip(event) {
	document.getElementById("fliprollie").style.display = "block";
}

function exitflip(event) {
	document.getElementById("fliprollie").style.display = "none";
}


